#!/usr/bin/env python
# -*- coding: utf-8 -*-

from xml.dom.minidom import parse, parseString
import urllib

class XmlDoc:
    def __init__(self,file="",xml="",url=""):
        if file:
            self.__dom = parse(file)
        elif xml:
            self.__dom = parseString(xml)
        elif url:
            f = urllib.urlopen(url)
            data = f.read()
            f.close()   
            self.__dom = parseString(data)
        else:
            raise "Xml marche pas"
    def getAll(self,n):
        return [XmlNode(i) for i in self.__dom.getElementsByTagName(n)]

class XmlNode:  # renvoi de l'utf8 ;-( ... comme libxml2
    def __init__(self,node):
        self.__node = node
    def getAttr(self,nom):
        return self.__node.getAttribute(nom).encode("utf_8")
    def getText(self):
        rc = u""
        for node in self.__node.childNodes:
            if node.nodeType == node.TEXT_NODE:
                rc = rc + node.data
        return rc.encode("utf_8")
        

if __name__ == "__main__":
    x=XmlDoc(xml="<a kif='k'>hgfd</a>")
    
    n= x.getAll("a")
    print n[0].getText()
    print n[0].getAttr("kif")
